/*
 * adc.c
 *
 *  Created on: 2022年4月14日
 *      Author: 86137
 */
#include "adc.h"


#define Val_To_V 0.0001611721612

void Init_ADC()
{
    R_ADC_Open(&g_adc0_ctrl, &g_adc0_cfg);//打开ADC
        R_ADC_ScanCfg(&g_adc0_ctrl, &g_adc0_channel_cfg);//配置ADC参数  g_adc0_channel_cfg
        R_ADC_ScanStart(&g_adc0_ctrl);//开启ADC扫描
}

void ADC_Scan(float *val)
{
    uint16_t V[3]={0};
    static uint8_t i=0;
    float Transformation = 0.00080586;

    R_ADC_Read(&g_adc0_ctrl, channel_VAC, &V[0]);//读ADC数据 VAC
    R_ADC_Read(&g_adc0_ctrl, channel_IAC, &V[1]);//读ADC数据 IAC
    R_ADC_Read(&g_adc0_ctrl, channel_IDC, &V[2]);//读ADC数据 IDC
    switch (i)
    {
        case 0:
            val[9]= (float)(V[0]);
            val[10]= (float)(V[1]);
            val[11]= (float)(V[2]);
        break;
        case 1:
            val[12]= (float)(V[0]);
            val[13]= (float)(V[1]);
            val[14]= (float)(V[2]);
        break;
        case 2:
            val[15]= (float)(V[0]);
            val[16]= (float)(V[1]);
            val[17]= (float)(V[2]);
        break;
        case 3:
            val[18]= (float)(V[0]);
            val[19]= (float)(V[1]);
            val[20]= (float)(V[2]);
        break;
        case 4:
            val[21]= (float)(V[0]);
            val[22]= (float)(V[1]);
            val[23]= (float)(V[2]);
        break;
        case 5:
            val[24]= (float)(V[0]);
            val[25]= (float)(V[1]);
            val[26]= (float)(V[2]);
        break;

        default:
                           /* Do Nothing */
        break;
        }
        if(i<=4)   i++;
        else
        {
            i=0;
             val[0]=((val[9]+val[12]+val[15]+val[18]+val[21]+val[24])/6);
             val[1]=((val[10]+val[13]+val[16]+val[19]+val[22]+val[25])/6);
             val[2]=((val[11]+val[14]+val[17]+val[20]+val[23]+val[26])/6);
             val[0]=val[0]*Transformation;
             val[1]=val[1]*Transformation;
             val[2]=val[2]*Transformation;
        }
}
