/*
 * oled.h
 *
 *  Created on: 2021年10月6日
 *      Author: Administrator
 */

#ifndef OLED_H_
#define OLED_H_
#include "stdint.h"
#include "Global/Global.h"

void Init_IIC(void);
void Init_OLED(void);
void OLED_WR_CMD(uint8_t cmd);
void OLED_WR_DATA(uint8_t data);
void OLED_Init(void);
void OLED_Clear(void);
void OLED_Display_On(void);
void OLED_Display_Off(void);
void OLED_Set_Pos(uint8_t x, uint8_t y);
void OLED_On(void);
unsigned int oled_pow(uint8_t m,uint8_t n);
void OLED_ShowNum(uint8_t x,uint8_t y,unsigned int num,uint8_t len,uint8_t size2);
void OLED_ShowChar(uint8_t x,uint8_t y,uint8_t chr,uint8_t Char_Size);
void OLED_ShowString(uint8_t x,uint8_t y,uint8_t *chr,uint8_t Char_Size);
void OLED_DrawBMP(unsigned char x0,unsigned char y0,unsigned char x1,unsigned char y1,unsigned char BMP[]);
void OLED_ShowFloat(uint8_t x,uint8_t y,float num,unsigned char interger,unsigned char decimal ,uint8_t Char_Size);
void DoubleToStr(float slope, unsigned char str[],int len);
void DisPlay(void);
void IIC_Slave_UnLock(void);
bsp_io_level_t Pin_Read(bsp_io_port_pin_t pin);

#endif /* OLED_H_ */

